rm(list = ls())

#rpertoire
setwd("d:/temp/temp")

#dplyr et readr font tous deux partie de tidyverse
#dplyr --> installe automatiquement tibble
library(dplyr)

#readr
library(readr)

#chargement - 51.37 sec.
system.time(D <- read_csv("kddcup99twice.txt",col_names=FALSE))

#type --> "spec_tbl_df" "tbl_df" "tbl" "data.frame" 
print(class(D))

#pour ne pas limiter l'affichage
options(tibble.print_min=Inf)

#description - 9796862 obs. of  42 variables
print(str(D))

#occupation mmoire - 3139.3 MB
#gestionnaire de tches - 3742.6 Mo
print(object.size(D)/(1024*1024))

#restriction - 382696 - 0.18 sec.
system.time(print(nrow(filter(D, X42=="normal.", X2=="udp"))))

#colonnes numriques
numeriques <- which(sapply(D,is.numeric))
print(numeriques)

#calculer les moyennes - 0.74 sec.
system.time(print(sapply(D %>% select(numeriques),mean)))

#calculer les moyennes avec une restriction - 0.49 sec.
system.time(print(sapply(D %>% filter(X42=="normal.") %>% select(numeriques),mean)))

#trier selon la variable V34 - 6.56 sec.
system.time(print(D %>% arrange(X34) %>% head))

#comptage de V42 - 0.38 sec.
system.time(print(D %>% group_by(X42) %>% summarise(n())))

#moyenne de V34 selon V42 - 0.44 sec.
system.time(print(D %>% group_by(X42) %>% summarise(mean(X34))))

#moyenne de V34 selon (V42, V2) - 0.59 sec.
system.time(print(D %>% group_by(X42,X2) %>% summarise(mean(X34))))
