# -*- coding: utf-8 -*-

#mesurer le temps
import time

#changer le répertoire courant
import os
os.chdir("d:/temp/temp")

#specifier les noms
noms = ["V"+str(i) for i in range(1,43)]

#importer les données - 124.42 sec.
import pandas
tag = time.perf_counter()
D = pandas.read_csv("kddcup99twice.txt",header=None,names=noms)
print(time.perf_counter()-tag)

#type --> <class 'pandas.core.frame.DataFrame'>
print(type(D))

#info - RangeIndex: 9796862 entries, 0 to 9796861
#Data columns (total 42 columns):
#gestionnaire de tâches : 3646.8 Mo
print(D.info())

#restriction - 382696 - 1.44 sec.
tag = time.perf_counter()
print(D.loc[(D.V42=="normal.") & (D.V2=="udp"),:].shape[0])
print(time.perf_counter()-tag)

#moyennes pour les variables numeriques - 1.75 sec.
tag = time.perf_counter()
print(D.mean(axis=0,numeric_only=True))
print(time.perf_counter()-tag)

#calculer les moyennes avec une restriction - 1.42 sec.
tag = time.perf_counter()
print(D.loc[D.V42=="normal.",:].mean(axis=0,numeric_only=True))
print(time.perf_counter()-tag)

#trier selon la variable V34 - 3.59 sec.
tag = time.perf_counter()
print(D.sort_values(by='V34').head())
print(time.perf_counter()-tag)

#comptage de V42 - 1.07 sec.
tag = time.perf_counter()
print(D.V42.value_counts())
print(time.perf_counter()-tag)

#moyenne de V34 selon V42 - 0.47 sec.
tag = time.perf_counter()
print(D.groupby('V42')['V34'].mean())
print(time.perf_counter()-tag)

#moyenne de V34 selon (V42, V2) - 1.52 sec.
tag = time.perf_counter()
print(pandas.crosstab(index=D.V42,columns=D.V2,values=D.V34,aggfunc=pandas.Series.mean))
print(time.perf_counter()-tag)

